package com.ruoyi.ehsMaterial.controller;

import java.util.List;
import java.util.Arrays;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;
import javax.servlet.http.HttpServletResponse;

import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.ehsRisk.domain.EhsRisk;
import com.ruoyi.materialClass.domain.MaterialClassMaster;
import com.ruoyi.materialClass.domain.MaterialClassSub;
import com.ruoyi.materialClass.mapper.MaterialClassSubMapper;
import com.ruoyi.materialClass.service.IMaterialClassMasterService;
import com.ruoyi.materialClass.service.IMaterialClassSubService;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.ehsMaterial.domain.EhsMaterial;
import com.ruoyi.ehsMaterial.service.IEhsMaterialService;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.common.core.page.TableDataInfo;
import org.springframework.web.multipart.MultipartFile;

/**
 * 物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”Controller
 *
 * @author ruoyi
 * @date 2023-12-04
 */
@Api(tags="物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”管理")
@RestController
@RequestMapping("/ehsMaterial/ehsMaterial")
public class EhsMaterialController extends BaseController
{
    @Autowired
    private IEhsMaterialService ehsMaterialService;
    @Autowired
    private IMaterialClassMasterService materialClassMastService;
    @Autowired
    private IMaterialClassSubService materialClassSubService;

    /**
     * 查询物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”列表
     */
    @PreAuthorize("@ss.hasPermi('ehsMaterial:ehsMaterial:list')")
    @GetMapping("/list")
    public TableDataInfo list(EhsMaterial ehsMaterial)
    {
        startPage();
        List<EhsMaterial> list = ehsMaterialService.selectEhsMateriallExportList(ehsMaterial);
        return getDataTable(list);
    }

    /**
     * 导出物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”列表
     */
    @PreAuthorize("@ss.hasPermi('ehsMaterial:ehsMaterial:export')")
    @Log(title = "物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, EhsMaterial ehsMaterial)
    {
        List<EhsMaterial> list = ehsMaterialService.selectEhsMaterialList(ehsMaterial);
        // 类别替换为中文
        MaterialClassMaster msm = new MaterialClassMaster();
        if(ehsMaterial.getClassFirst()!=null){
            msm.setClassMastType(ehsMaterial.getClassFirst().toString());
        }
        List<MaterialClassMaster> materialClassMasters = materialClassMastService.selectMaterialClassMastList(msm);
        // 物资分类一级分类对象,对应的是"类别"字段;收集为map,key是 v1,v2,v3... value是"常用工具","个人防护物资和装备"...
        Map<String, String> map1 = materialClassMasters.stream().collect(Collectors.toMap(MaterialClassMaster::getClassMastId, MaterialClassMaster::getClassNameMast));
        // 物资名称替换为中文
        MaterialClassSub mcs = new MaterialClassSub();
        mcs.setClassMastType(ehsMaterial.getClassFirst().toString());
        List<MaterialClassSub> mlist = materialClassSubService.selectMaterialClassSubList(mcs);
        // 物资分类二级分类对象,对应的是"物资名称"字段;收集为map,key是 v1-1,v1-2,v2-1... value是"卫星电话"...
        Map<String, String> map2 = mlist.stream()
                .collect(Collectors.toMap(MaterialClassSub::getClassSubId, MaterialClassSub::getClassNameSub));
        list.stream().forEach((item)->{
            String value = map1.get(item.getClassSecond());
            if (StringUtils.isNotBlank(value)) {
                item.setClassSecond(value);
            }
            String val = map2.get(item.getMaterialName());
            if (StringUtils.isNotBlank(val)) {
                item.setMaterialName(val);
            }
        });
        ExcelUtil<EhsMaterial> util = new ExcelUtil<EhsMaterial>(EhsMaterial.class);
        util.exportExcel(response, list, "物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”数据");
    }

    /**
     * 获取物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”详细信息
     */
    @PreAuthorize("@ss.hasPermi('ehsMaterial:ehsMaterial:query')")
    @GetMapping(value = "/{materialId}")
    public AjaxResult getInfo(@PathVariable("materialId") Long materialId)
    {
        return success(ehsMaterialService.selectEhsMaterialByMaterialId(materialId));
    }

    /**
     * 新增物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”
     */
    @ApiOperation("新增物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”")
    @PreAuthorize("@ss.hasPermi('ehsMaterial:ehsMaterial:add')")
    @Log(title = "物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody EhsMaterial ehsMaterial)
    {
        return toAjax(ehsMaterialService.save(ehsMaterial));
    }

    /**
     * 修改物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”
     */
    @ApiOperation("修改物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”")
    @PreAuthorize("@ss.hasPermi('ehsMaterial:ehsMaterial:edit')")
    @Log(title = "物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody EhsMaterial ehsMaterial)
    {
        return toAjax(ehsMaterialService.updateById(ehsMaterial));
    }

    /**
     * 删除物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”
     */
    @ApiOperation("删除物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”")
    @PreAuthorize("@ss.hasPermi('ehsMaterial:ehsMaterial:remove')")
    @Log(title = "物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”", businessType = BusinessType.DELETE)
    @DeleteMapping("/{materialIds}")
    public AjaxResult remove(@PathVariable Long[] materialIds)
    {
        return toAjax(ehsMaterialService.removeByIds(Arrays.asList(materialIds)));
    }

    @PostMapping("/importTemplate")
    public void importTemplate(HttpServletResponse response) throws Exception {
        ExcelUtil<EhsMaterial> util = new ExcelUtil<EhsMaterial>(EhsMaterial.class);
        util.importComboTemplateExcel(response, "物资信息数据");
    }
    /**
     * 批量导入
     */
    @PostMapping("/importData/{classType}")
    public AjaxResult importHubManage(@PathVariable String classType,MultipartFile file, Boolean updateSupport) throws Exception {
        ExcelUtil<EhsMaterial> util = new ExcelUtil<>(EhsMaterial.class);
        List<EhsMaterial> list = util.importExcel(file.getInputStream());
        String message = ehsMaterialService.importMaterial(list,classType, updateSupport);
        return AjaxResult.success(message);
    }
}